; NOTE:
; You may change the string length, or its case, and see results and timings also.
;
; If comment next macro - used shorter variand of Axhex2dw proc
UseFastestVariant EQU 1
; If this macro is defined, used more speedy and slightly longer Axhex2dw proc,
; if macro is not defined, used shortes and slightly slower proc.

.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000
option scoped


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD

Axhex2dw_Unrolled_AMD PROTO :DWORD
Axhex2dw_Unrolled PROTO :DWORD



.data

align  16
hexstring    db  "ABCDEF01",0

;align 16
;numstring          db  "1234543210",0
;align 16
;negnumstring   db  "-1234543210",0

.code
start:

	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@

	print "Alex's versions",13,10	
	print "All algos work on i386+ CPUs",13,10
	

	REPEAT 1

	invoke Sleep, 200
	
	invoke Axhex2dw_Unrolled, addr  hexstring
	print hex$(eax),9,"Result of Unrolled",13,10
	invoke Axhex2dw_Unrolled_AMD, addr  hexstring
	print hex$(eax),9,"Result of Unrolled (AMD)",13,10
	invoke Axhex2dw, addr  hexstring
	print hex$(eax),9,"Result of Short",13,10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Unrolled, addr  hexstring
    counter_end
	     print str$(eax), 9, "cycles for Fast version", 13, 10

	invoke Sleep, 200
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Unrolled_AMD, addr  hexstring
    counter_end
		print str$(eax), 9, "cycles for Fast version under AMD", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small version in faster compilation", 13, 10


	invoke Sleep, 200


	ENDM
	

	print " ", 13, 10
	print "Codesizes:", 13, 10
	print "Axhex2dw_Unrolled:", 9
	mov   eax, Axhex2dw_endp_Unrolled
	sub	  eax, Axhex2dw_Unrolled
	print str$(eax), 13, 10

	print "Axhex2dw_Unrolled_AMD:", 9
	mov   eax, Axhex2dw_endp_Unrolled_AMD
	sub	  eax, Axhex2dw_Unrolled_AMD
	print str$(eax), 13, 10
	
	
	print "Axhex2dw - Small:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	

align 16
	;#############################################################	
ifndef UseFastestVariant
	; If macro defined, then:
	; align proc to 4 bytes, and main loop of proc to 16 bytes
db 0CCh,0CCh,0CCh,0CCh ; shifting to align main loop at 16 bytes
endif
Axhex2dw    proc STDCALL lpszStr:DWORD
	;int 3


	;#############################################################	
ifndef UseFastestVariant

	; If macro defined, then:
	; Using simple and standard methodic to getting argument,
	; and shorter form of code: zero eax via "xor" and preprocess first
	; pass via jumping to start of next pass

	mov edx,[esp+4]
	xor eax,eax
	mov [esp+4],edi
	
	jmp @preloop
	
else	;#############################################################

	; If macro NOT defined, then:
	; Using "witch-doctor's" methodics with long form of instructions
	; And code is slightly longer, but, on my PC, faster.
	
	;binary code of
	;mov edx,[esp+(DWORD)4]
	;db 8bh,94h,24h,4,0,0,0
	
	mov edx,[esp+4]
	
	mov eax,0
	
	;binary code of
	;mov [esp+(DWORD)4],edi
	db 89h,0bch,24h,4,0,0,0
	
	;binary code of
	;movzx ecx,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,4Ah,0
	;movzx ecx,byte ptr [edx]
	
	;binary code of
	;movzx edi,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,7Ah,0
	
	;test ecx,ecx
	;binary code of
	;cmp ecx,(DWORD)0
	db 81h,0F9h,0,0,0,0
	jz @done
	;and edi,1111Y
endif
	;#############################################################
	;comment ~
	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	add edx,1
	shl eax,4
	lea edi,[edi+ecx*8]
	add eax,ecx
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	;~
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw    endp
Axhex2dw_endp:

align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled    endp
Axhex2dw_endp_Unrolled:


align 16
Axhex2dw_Unrolled_AMD    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	push esi
	push edi
	push ebx

	UNIT TEXTEQU <DWORD>
	
	mov eax,0
	
	movzx esi,byte ptr [edx]
	movzx edi,byte ptr [edx+1]

	cmp esi,0
	jz @done
	mov eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+2]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+3]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	movzx esi,byte ptr [edx+4]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]
	movzx edi,byte ptr [edx+5]
	cmp esi,0
	jz @done
	shl eax,4
	
	
	
	add eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+6]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+7]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]


	@done:
	pop ebx
	pop edi
	pop esi
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled_AMD    endp
Axhex2dw_endp_Unrolled_AMD:


option prologue:prologuedef
option epilogue:epiloguedef

end start

